﻿using System.ComponentModel;

namespace WpfApplication1
{
	public class Member : INotifyPropertyChanged, IPath
	{
		private string name;

		public Member(string name)
		{
			this.Name = name;
		}

		public string Name
		{
			get
			{
				return this.name;
			}
			set
			{
				if (this.name != value)
				{
					this.name = value;
					OnNotifyPropertyChanged("Name");
				}
			}
		}
		
		#region INotifyPropertyChanged Members

		public event PropertyChangedEventHandler PropertyChanged;
		private void OnNotifyPropertyChanged(string propertyName)
		{
			if (PropertyChanged != null)
			{
				PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
			}
		}

		#endregion

		public string GetFullPath()
		{
			if (this.Parent != null)
			{
				return this.Parent.GetFullPath() + "|" + this.ToString();
			}
			return this.ToString();
		}

		public IPath Parent
		{
			get;
			set;
		}

		public override string ToString()
		{
			return this.Name;
		}
	}
}
