﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Telerik.Windows.Controls;
using System.Windows.Automation;
using System.Collections.ObjectModel;

namespace WpfApplication1
{
	/// <summary>
	/// Interaction logic for Window1.xaml
	/// </summary>
	public partial class Window1 : Window
	{
		private Families families = new Families();
		private ObservableCollection<string> checkedItemNames = new ObservableCollection<string>();

		public Window1()
		{
			InitializeComponent();

			this.treeView1.ItemsSource = this.families;
			this.Log.ItemsSource = this.checkedItemNames;
		}

		private void Button_Click(object sender, RoutedEventArgs e)
		{
			// clear the collection before populating
			this.checkedItemNames.Clear();
			
			foreach (Family family in this.families)
			{
				// get the container
				var familyContainer = this.GetContainer(family.GetFullPath());
				// check if the container is checked
				if (familyContainer != null && familyContainer.CheckState == ToggleState.On)
				{
					this.checkedItemNames.Add(family.Name);
				}
				// look for checked members in a family
				foreach (Member member in family.Members)
				{
					// get the container
					var memberContainer = this.GetContainer(member.GetFullPath());
					// check if the container is checked
					if (memberContainer != null && memberContainer.CheckState == ToggleState.On)
					{
						this.checkedItemNames.Add(member.Name);
					}
				}
			}
		}

		private RadTreeViewItem GetContainer(string path)
		{
			return this.treeView1.GetItemByPath(path, "|");
		}
	}
}
